package com.example.libmedia.demo.video;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.os.Bundle;
import android.util.Log;
import android.webkit.WebView;

import fr.maxcom.http.HttpServer;
import fr.maxcom.http.LocalSingleHttpServer;

import java.security.GeneralSecurityException;

import javax.crypto.Cipher;

/**
 * This class centralizes the code shared between variants of WebView Activities.
 * Refer to WebActivity1 and WebActivity2 for runnable activities.
 */
public abstract class AWebActivity extends Activity {
	private static final String TAG = "PlayActivity";

	private LocalSingleHttpServer mServer;

	// to be implemented in concrete activities
	protected abstract Cipher getCipher() throws GeneralSecurityException;
	protected abstract void demo(WebView webview, HttpServer server);

	@SuppressLint("SetJavaScriptEnabled")
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		final WebView webview = new WebView(this);
		setContentView(webview);

		webview.getSettings().setJavaScriptEnabled(true);

		try {
			mServer = new LocalSingleHttpServer();
			final Cipher c = getCipher();
			if (c != null) {  // null means a clear video ; no need to set a decryption processing
				mServer.setCipher(c);
			}
			mServer.start();
			demo(webview, mServer);
		} catch (Exception e) {  // exception management is not implemented in this demo code
			// Auto-generated catch block
			e.printStackTrace();
		}
	}

	@Override
	protected void onDestroy() {
		Log.d(TAG, "onDestroy");
		// may be, do some cleanup in case of paused or currently playing
		if (mServer != null) {	// explicit is better
			mServer.stop();
			mServer = null;
		}
		super.onDestroy();
	}
}
